Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4440)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4441)
@@ -23,5 +23,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Change order of dimension in surface arrays %frac, %emissivity and %albedo 
+! to allow for better vectorization in the radiation interactions.
 ! 
 ! Former revisions:
@@ -800,10 +801,10 @@
 !--     Allocate albedo_type and albedo. Each surface element
 !--     has 3 values, 0: wall fraction, 1: green fraction, 2: window fraction.
-        ALLOCATE ( surf_usm_h%albedo_type(0:2,1:surf_usm_h%ns) )
-        ALLOCATE ( surf_usm_h%albedo(0:2,1:surf_usm_h%ns)      )
+        ALLOCATE ( surf_usm_h%albedo_type(1:surf_usm_h%ns,0:2) )
+        ALLOCATE ( surf_usm_h%albedo(1:surf_usm_h%ns,0:2)      )
         surf_usm_h%albedo_type = albedo_type
         DO  l = 0, 3
-           ALLOCATE ( surf_usm_v(l)%albedo_type(0:2,1:surf_usm_v(l)%ns) )
-           ALLOCATE ( surf_usm_v(l)%albedo(0:2,1:surf_usm_v(l)%ns)      )
+           ALLOCATE ( surf_usm_v(l)%albedo_type(1:surf_usm_v(l)%ns,0:2) )
+           ALLOCATE ( surf_usm_v(l)%albedo(1:surf_usm_v(l)%ns,0:2)      )
            surf_usm_v(l)%albedo_type = albedo_type
         ENDDO       
@@ -837,8 +838,8 @@
 !--      Allocate arrays for relative surface fraction. 
 !--      0 - wall fraction, 1 - green fraction, 2 - window fraction
-         ALLOCATE ( surf_usm_h%frac(0:2,1:surf_usm_h%ns) )
+         ALLOCATE ( surf_usm_h%frac(1:surf_usm_h%ns,0:2) )
          surf_usm_h%frac = 0.0_wp
          DO  l = 0, 3
-            ALLOCATE ( surf_usm_v(l)%frac(0:2,1:surf_usm_v(l)%ns) )
+            ALLOCATE ( surf_usm_v(l)%frac(1:surf_usm_v(l)%ns,0:2) )
             surf_usm_v(l)%frac = 0.0_wp
          ENDDO
@@ -855,5 +856,5 @@
         ALLOCATE ( surf_usm_h%transmissivity(1:surf_usm_h%ns)     )
         ALLOCATE ( surf_usm_h%lai(1:surf_usm_h%ns)                )
-        ALLOCATE ( surf_usm_h%emissivity(0:2,1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%emissivity(1:surf_usm_h%ns,0:2)     )
         ALLOCATE ( surf_usm_h%r_a(1:surf_usm_h%ns)                )
         ALLOCATE ( surf_usm_h%r_a_green(1:surf_usm_h%ns)          )
@@ -873,5 +874,5 @@
            ALLOCATE ( surf_usm_v(l)%transmissivity(1:surf_usm_v(l)%ns)     )
            ALLOCATE ( surf_usm_v(l)%lai(1:surf_usm_v(l)%ns)                )
-           ALLOCATE ( surf_usm_v(l)%emissivity(0:2,1:surf_usm_v(l)%ns)     )
+           ALLOCATE ( surf_usm_v(l)%emissivity(1:surf_usm_v(l)%ns,0:2)     )
            ALLOCATE ( surf_usm_v(l)%r_a(1:surf_usm_v(l)%ns)                )
            ALLOCATE ( surf_usm_v(l)%r_a_green(1:surf_usm_v(l)%ns)          )
@@ -3616,7 +3617,7 @@
 !
 !--        Initialize relatvie wall- (0), green- (1) and window (2) fractions
-           surf_usm_h%frac(ind_veg_wall,m)  = building_pars(ind_wall_frac_r,building_type)   
-           surf_usm_h%frac(ind_pav_green,m) = building_pars(ind_green_frac_r,building_type)  
-           surf_usm_h%frac(ind_wat_win,m)   = building_pars(ind_win_frac_r,building_type)  
+           surf_usm_h%frac(m,ind_veg_wall)  = building_pars(ind_wall_frac_r,building_type)   
+           surf_usm_h%frac(m,ind_pav_green) = building_pars(ind_green_frac_r,building_type)  
+           surf_usm_h%frac(m,ind_wat_win)   = building_pars(ind_win_frac_r,building_type)  
            surf_usm_h%lai(m)                = building_pars(ind_lai_r,building_type)  
 
@@ -3650,7 +3651,7 @@
 !
 !--        emissivity of wall-, green- and window fraction 
-           surf_usm_h%emissivity(ind_veg_wall,m)  = building_pars(ind_emis_wall_r,building_type)
-           surf_usm_h%emissivity(ind_pav_green,m) = building_pars(ind_emis_green_r,building_type)
-           surf_usm_h%emissivity(ind_wat_win,m)   = building_pars(ind_emis_win_r,building_type)
+           surf_usm_h%emissivity(m,ind_veg_wall)  = building_pars(ind_emis_wall_r,building_type)
+           surf_usm_h%emissivity(m,ind_pav_green) = building_pars(ind_emis_green_r,building_type)
+           surf_usm_h%emissivity(m,ind_wat_win)   = building_pars(ind_emis_win_r,building_type)
 
            surf_usm_h%transmissivity(m)      = building_pars(ind_trans_r,building_type)
@@ -3661,7 +3662,7 @@
 !
 !--        albedo type for wall fraction, green fraction, window fraction
-           surf_usm_h%albedo_type(ind_veg_wall,m)  = INT( building_pars(ind_alb_wall_r,building_type)  )
-           surf_usm_h%albedo_type(ind_pav_green,m) = INT( building_pars(ind_alb_green_r,building_type) )
-           surf_usm_h%albedo_type(ind_wat_win,m)   = INT( building_pars(ind_alb_win_r,building_type)   )
+           surf_usm_h%albedo_type(m,ind_veg_wall)  = INT( building_pars(ind_alb_wall_r,building_type)  )
+           surf_usm_h%albedo_type(m,ind_pav_green) = INT( building_pars(ind_alb_green_r,building_type) )
+           surf_usm_h%albedo_type(m,ind_wat_win)   = INT( building_pars(ind_alb_win_r,building_type)   )
 
            surf_usm_h%zw(nzb_wall,m)         = building_pars(ind_thick_1_wall_r,building_type)
@@ -3774,7 +3775,7 @@
 !
 !--           Initialize relatvie wall- (0), green- (1) and window (2) fractions
-              surf_usm_v(l)%frac(ind_veg_wall,m)   = building_pars(ind_wall_frac,building_type)   
-              surf_usm_v(l)%frac(ind_pav_green,m)  = building_pars(ind_green_frac_w,building_type) 
-              surf_usm_v(l)%frac(ind_wat_win,m)    = building_pars(ind_win_frac,building_type)  
+              surf_usm_v(l)%frac(m,ind_veg_wall)   = building_pars(ind_wall_frac,building_type)   
+              surf_usm_v(l)%frac(m,ind_pav_green)  = building_pars(ind_green_frac_w,building_type) 
+              surf_usm_v(l)%frac(m,ind_wat_win)    = building_pars(ind_win_frac,building_type)  
               surf_usm_v(l)%lai(m)                 = building_pars(ind_lai_w,building_type)  
 
@@ -3813,7 +3814,7 @@
 !
 !--           emissivity of wall-, green- and window fraction 
-              surf_usm_v(l)%emissivity(ind_veg_wall,m)  = building_pars(ind_emis_wall,building_type)
-              surf_usm_v(l)%emissivity(ind_pav_green,m) = building_pars(ind_emis_green,building_type)
-              surf_usm_v(l)%emissivity(ind_wat_win,m)   = building_pars(ind_emis_win,building_type)
+              surf_usm_v(l)%emissivity(m,ind_veg_wall)  = building_pars(ind_emis_wall,building_type)
+              surf_usm_v(l)%emissivity(m,ind_pav_green) = building_pars(ind_emis_green,building_type)
+              surf_usm_v(l)%emissivity(m,ind_wat_win)   = building_pars(ind_emis_win,building_type)
 
               surf_usm_v(l)%transmissivity(m)      = building_pars(ind_trans,building_type)
@@ -3823,7 +3824,7 @@
               surf_usm_v(l)%z0q(m)                 = building_pars(ind_z0qh,building_type)
 
-              surf_usm_v(l)%albedo_type(ind_veg_wall,m)  = INT( building_pars(ind_alb_wall,building_type) )
-              surf_usm_v(l)%albedo_type(ind_pav_green,m) = INT( building_pars(ind_alb_green,building_type) )
-              surf_usm_v(l)%albedo_type(ind_wat_win,m)   = INT( building_pars(ind_alb_win,building_type) )
+              surf_usm_v(l)%albedo_type(m,ind_veg_wall)  = INT( building_pars(ind_alb_wall,building_type) )
+              surf_usm_v(l)%albedo_type(m,ind_pav_green) = INT( building_pars(ind_alb_green,building_type) )
+              surf_usm_v(l)%albedo_type(m,ind_wat_win)   = INT( building_pars(ind_alb_win,building_type) )
 
               surf_usm_v(l)%zw(nzb_wall,m)         = building_pars(ind_thick_1,building_type)
@@ -3880,7 +3881,7 @@
 !
 !--              Initialize relatvie wall- (0), green- (1) and window (2) fractions
-                 surf_usm_h%frac(ind_veg_wall,m)  = building_pars(ind_wall_frac_r,st)   
-                 surf_usm_h%frac(ind_pav_green,m) = building_pars(ind_green_frac_r,st)  
-                 surf_usm_h%frac(ind_wat_win,m)   = building_pars(ind_win_frac_r,st)  
+                 surf_usm_h%frac(m,ind_veg_wall)  = building_pars(ind_wall_frac_r,st)   
+                 surf_usm_h%frac(m,ind_pav_green) = building_pars(ind_green_frac_r,st)  
+                 surf_usm_h%frac(m,ind_wat_win)   = building_pars(ind_win_frac_r,st)  
                  surf_usm_h%lai(m)                = building_pars(ind_lai_r,st)  
 
@@ -3916,7 +3917,7 @@
 !
 !--              emissivity of wall-, green- and window fraction 
-                 surf_usm_h%emissivity(ind_veg_wall,m)  = building_pars(ind_emis_wall_r,st)
-                 surf_usm_h%emissivity(ind_pav_green,m) = building_pars(ind_emis_green_r,st)
-                 surf_usm_h%emissivity(ind_wat_win,m)   = building_pars(ind_emis_win_r,st)
+                 surf_usm_h%emissivity(m,ind_veg_wall)  = building_pars(ind_emis_wall_r,st)
+                 surf_usm_h%emissivity(m,ind_pav_green) = building_pars(ind_emis_green_r,st)
+                 surf_usm_h%emissivity(m,ind_wat_win)   = building_pars(ind_emis_win_r,st)
 
                  surf_usm_h%transmissivity(m)      = building_pars(ind_trans_r,st)
@@ -3927,7 +3928,7 @@
 !
 !--              albedo type for wall fraction, green fraction, window fraction
-                 surf_usm_h%albedo_type(ind_veg_wall,m)  = INT( building_pars(ind_alb_wall_r,st) )
-                 surf_usm_h%albedo_type(ind_pav_green,m) = INT( building_pars(ind_alb_green_r,st) )
-                 surf_usm_h%albedo_type(ind_wat_win,m)   = INT( building_pars(ind_alb_win_r,st) )
+                 surf_usm_h%albedo_type(m,ind_veg_wall)  = INT( building_pars(ind_alb_wall_r,st) )
+                 surf_usm_h%albedo_type(m,ind_pav_green) = INT( building_pars(ind_alb_green_r,st) )
+                 surf_usm_h%albedo_type(m,ind_wat_win)   = INT( building_pars(ind_alb_win_r,st) )
 
                  surf_usm_h%zw(nzb_wall,m)         = building_pars(ind_thick_1_wall_r,st)
@@ -4047,7 +4048,7 @@
 !
 !--                 Initialize relatvie wall- (0), green- (1) and window (2) fractions
-                    surf_usm_v(l)%frac(ind_veg_wall,m)  = building_pars(ind_wall_frac,st)   
-                    surf_usm_v(l)%frac(ind_pav_green,m) = building_pars(ind_green_frac_w,st)  
-                    surf_usm_v(l)%frac(ind_wat_win,m)   = building_pars(ind_win_frac,st)   
+                    surf_usm_v(l)%frac(m,ind_veg_wall)  = building_pars(ind_wall_frac,st)   
+                    surf_usm_v(l)%frac(m,ind_pav_green) = building_pars(ind_green_frac_w,st)  
+                    surf_usm_v(l)%frac(m,ind_wat_win)   = building_pars(ind_win_frac,st)   
                     surf_usm_v(l)%lai(m)                = building_pars(ind_lai_w,st)  
 
@@ -4086,7 +4087,7 @@
 !
 !--                 emissivity of wall-, green- and window fraction 
-                    surf_usm_v(l)%emissivity(ind_veg_wall,m)  = building_pars(ind_emis_wall,st)
-                    surf_usm_v(l)%emissivity(ind_pav_green,m) = building_pars(ind_emis_green,st)
-                    surf_usm_v(l)%emissivity(ind_wat_win,m)   = building_pars(ind_emis_win,st)
+                    surf_usm_v(l)%emissivity(m,ind_veg_wall)  = building_pars(ind_emis_wall,st)
+                    surf_usm_v(l)%emissivity(m,ind_pav_green) = building_pars(ind_emis_green,st)
+                    surf_usm_v(l)%emissivity(m,ind_wat_win)   = building_pars(ind_emis_win,st)
 
                     surf_usm_v(l)%transmissivity(m)      = building_pars(ind_trans,st)
@@ -4096,7 +4097,7 @@
                     surf_usm_v(l)%z0q(m)                 = building_pars(ind_z0qh,st)
 
-                    surf_usm_v(l)%albedo_type(ind_veg_wall,m)  = INT( building_pars(ind_alb_wall,st) )
-                    surf_usm_v(l)%albedo_type(ind_pav_green,m) = INT( building_pars(ind_alb_green,st) )
-                    surf_usm_v(l)%albedo_type(ind_wat_win,m)   = INT( building_pars(ind_alb_win,st) )
+                    surf_usm_v(l)%albedo_type(m,ind_veg_wall)  = INT( building_pars(ind_alb_wall,st) )
+                    surf_usm_v(l)%albedo_type(m,ind_pav_green) = INT( building_pars(ind_alb_green,st) )
+                    surf_usm_v(l)%albedo_type(m,ind_wat_win)   = INT( building_pars(ind_alb_win,st) )
 
                     surf_usm_v(l)%zw(nzb_wall,m)         = building_pars(ind_thick_1,st)
@@ -4193,15 +4194,15 @@
               IF ( building_pars_f%pars_xy(ind_wall_frac,j,i) /=               &
                    building_pars_f%fill )                                      &
-                 surf_usm_h%frac(ind_veg_wall,m)  =                            &
+                 surf_usm_h%frac(m,ind_veg_wall)  =                            &
                                     building_pars_f%pars_xy(ind_wall_frac,j,i)   
                  
               IF ( building_pars_f%pars_xy(ind_green_frac_r,j,i) /=            &          
                    building_pars_f%fill )                                      & 
-                 surf_usm_h%frac(ind_pav_green,m) =                            &
+                 surf_usm_h%frac(m,ind_pav_green) =                            &
                                     building_pars_f%pars_xy(ind_green_frac_r,j,i) 
                  
               IF ( building_pars_f%pars_xy(ind_win_frac,j,i) /=                &
                    building_pars_f%fill )                                      & 
-                 surf_usm_h%frac(ind_wat_win,m)   =                            &
+                 surf_usm_h%frac(m,ind_wat_win)   =                            &
                                     building_pars_f%pars_xy(ind_win_frac,j,i)
  
@@ -4325,15 +4326,15 @@
               IF ( building_pars_f%pars_xy(ind_emis_wall,j,i) /=               &   
                    building_pars_f%fill )                                      &
-                 surf_usm_h%emissivity(ind_veg_wall,m)  =                      &
+                 surf_usm_h%emissivity(m,ind_veg_wall)  =                      &
                                     building_pars_f%pars_xy(ind_emis_wall,j,i)
                  
               IF ( building_pars_f%pars_xy(ind_emis_green,j,i) /=              &            
                    building_pars_f%fill )                                      &
-                 surf_usm_h%emissivity(ind_pav_green,m) =                      &
+                 surf_usm_h%emissivity(m,ind_pav_green) =                      &
                                      building_pars_f%pars_xy(ind_emis_green,j,i)
                  
               IF ( building_pars_f%pars_xy(ind_emis_win,j,i) /=                & 
                    building_pars_f%fill )                                      &
-                 surf_usm_h%emissivity(ind_wat_win,m)   =                      &
+                 surf_usm_h%emissivity(m,ind_wat_win)   =                      &
                                      building_pars_f%pars_xy(ind_emis_win,j,i)
                  
@@ -4356,14 +4357,14 @@
               IF ( building_pars_f%pars_xy(ind_alb_wall_agfl,j,i) /=           &          
                    building_pars_f%fill )                                      & 
-                 surf_usm_h%albedo_type(ind_veg_wall,m)  =                     &
+                 surf_usm_h%albedo_type(m,ind_veg_wall)  =                     &
                                  building_pars_f%pars_xy(ind_alb_wall_agfl,j,i)
                  
               IF ( building_pars_f%pars_xy(ind_alb_green_agfl,j,i) /=          &           
                    building_pars_f%fill )                                      &
-                 surf_usm_h%albedo_type(ind_pav_green,m) =                     &
+                 surf_usm_h%albedo_type(m,ind_pav_green) =                     &
                                 building_pars_f%pars_xy(ind_alb_green_agfl,j,i)
               IF ( building_pars_f%pars_xy(ind_alb_win_agfl,j,i) /=            &          
                    building_pars_f%fill )                                      &
-                 surf_usm_h%albedo_type(ind_wat_win,m)   =                     &
+                 surf_usm_h%albedo_type(m,ind_wat_win)   =                     &
                                    building_pars_f%pars_xy(ind_alb_win_agfl,j,i)
 
@@ -4481,15 +4482,15 @@
                     IF ( building_pars_f%pars_xy(ind_wall_frac,j,i) /=         &
                          building_pars_f%fill )                                &
-                       surf_usm_v(l)%frac(ind_veg_wall,m)  =                   &
+                       surf_usm_v(l)%frac(m,ind_veg_wall)  =                   &
                                           building_pars_f%pars_xy(ind_wall_frac,j,i)   
                        
                     IF ( building_pars_f%pars_xy(ind_green_frac_w,j,i) /=      &          
                          building_pars_f%fill )                                & 
-                       surf_usm_v(l)%frac(ind_pav_green,m) =                   &
+                       surf_usm_v(l)%frac(m,ind_pav_green) =                   &
                                   building_pars_f%pars_xy(ind_green_frac_w,j,i) 
                        
                     IF ( building_pars_f%pars_xy(ind_win_frac,j,i) /=          &
                          building_pars_f%fill )                                & 
-                       surf_usm_v(l)%frac(ind_wat_win,m)   =                   &
+                       surf_usm_v(l)%frac(m,ind_wat_win)   =                   &
                                        building_pars_f%pars_xy(ind_win_frac,j,i)
                     
@@ -4614,15 +4615,15 @@
                     IF ( building_pars_f%pars_xy(ind_emis_wall,j,i) /=         &   
                          building_pars_f%fill )                                &
-                       surf_usm_v(l)%emissivity(ind_veg_wall,m)  =             &
+                       surf_usm_v(l)%emissivity(m,ind_veg_wall)  =             &
                                       building_pars_f%pars_xy(ind_emis_wall,j,i)
                        
                     IF ( building_pars_f%pars_xy(ind_emis_green,j,i) /=        &            
                          building_pars_f%fill )                                &
-                       surf_usm_v(l)%emissivity(ind_pav_green,m) =             &
+                       surf_usm_v(l)%emissivity(m,ind_pav_green) =             &
                                       building_pars_f%pars_xy(ind_emis_green,j,i)
                        
                     IF ( building_pars_f%pars_xy(ind_emis_win,j,i) /=          & 
                          building_pars_f%fill )                                &
-                       surf_usm_v(l)%emissivity(ind_wat_win,m)   =             &
+                       surf_usm_v(l)%emissivity(m,ind_wat_win)   =             &
                                       building_pars_f%pars_xy(ind_emis_win,j,i)
                        
@@ -4647,14 +4648,14 @@
                     IF ( building_pars_f%pars_xy(ind_alb_wall_agfl,j,i) /=     &          
                          building_pars_f%fill )                                & 
-                       surf_usm_v(l)%albedo_type(ind_veg_wall,m)  =            &
+                       surf_usm_v(l)%albedo_type(m,ind_veg_wall)  =            &
                                  building_pars_f%pars_xy(ind_alb_wall_agfl,j,i)
                        
                     IF ( building_pars_f%pars_xy(ind_alb_green_agfl,j,i) /=    &           
                          building_pars_f%fill )                                &
-                       surf_usm_v(l)%albedo_type(ind_pav_green,m) =            &
+                       surf_usm_v(l)%albedo_type(m,ind_pav_green) =            &
                                  building_pars_f%pars_xy(ind_alb_green_agfl,j,i)
                     IF ( building_pars_f%pars_xy(ind_alb_win_agfl,j,i) /=      &          
                          building_pars_f%fill )                                &
-                       surf_usm_v(l)%albedo_type(ind_wat_win,m)   =            &
+                       surf_usm_v(l)%albedo_type(m,ind_wat_win)   =            &
                                    building_pars_f%pars_xy(ind_alb_win_agfl,j,i)
                     
@@ -4730,15 +4731,15 @@
                     IF ( building_surface_pars_f%pars(ind_s_wall_frac,is) /=                     &
                          building_surface_pars_f%fill )                                          &
-                       surf_usm_h%frac(ind_veg_wall,m) =                                         &
+                       surf_usm_h%frac(m,ind_veg_wall) =                                         &
                                 building_surface_pars_f%pars(ind_s_wall_frac,is)
 
                     IF ( building_surface_pars_f%pars(ind_s_green_frac_w,is) /=                  &
                          building_surface_pars_f%fill )                                          &
-                       surf_usm_h%frac(ind_pav_green,m) =                                        &
+                       surf_usm_h%frac(m,ind_pav_green) =                                        &
                                 building_surface_pars_f%pars(ind_s_green_frac_w,is)
 
                     IF ( building_surface_pars_f%pars(ind_s_green_frac_r,is) /=                  &
                          building_surface_pars_f%fill )                                          &
-                       surf_usm_h%frac(ind_pav_green,m) =                                        &
+                       surf_usm_h%frac(m,ind_pav_green) =                                        &
                                 building_surface_pars_f%pars(ind_s_green_frac_r,is)
                                 !TODO clarify: why should _w and _r be on the same surface?
@@ -4746,5 +4747,5 @@
                     IF ( building_surface_pars_f%pars(ind_s_win_frac,is) /=                      &
                          building_surface_pars_f%fill )                                          &
-                       surf_usm_h%frac(ind_wat_win,m) =                                          &
+                       surf_usm_h%frac(m,ind_wat_win) =                                          &
                                 building_surface_pars_f%pars(ind_s_win_frac,is)
 
@@ -4826,15 +4827,15 @@
                     IF ( building_surface_pars_f%pars(ind_s_emis_wall,is) /=                     &
                          building_surface_pars_f%fill )                                          &
-                       surf_usm_h%emissivity(ind_veg_wall,m) =                                   &
+                       surf_usm_h%emissivity(m,ind_veg_wall) =                                   &
                                 building_surface_pars_f%pars(ind_s_emis_wall,is)
 
                     IF ( building_surface_pars_f%pars(ind_s_emis_green,is) /=                    &
                          building_surface_pars_f%fill )                                          &
-                       surf_usm_h%emissivity(ind_pav_green,m) =                                  &
+                       surf_usm_h%emissivity(m,ind_pav_green) =                                  &
                                 building_surface_pars_f%pars(ind_s_emis_green,is)
 
                     IF ( building_surface_pars_f%pars(ind_s_emis_win,is) /=                      &
                          building_surface_pars_f%fill )                                          &
-                       surf_usm_h%emissivity(ind_wat_win,m) =                                    &
+                       surf_usm_h%emissivity(m,ind_wat_win) =                                    &
                                 building_surface_pars_f%pars(ind_s_emis_win,is)
 
@@ -4877,15 +4878,15 @@
                        IF ( building_surface_pars_f%pars(ind_s_wall_frac,is) /=                &
                             building_surface_pars_f%fill )                                     &
-                          surf_usm_v(l)%frac(ind_veg_wall,m) =                                 &
+                          surf_usm_v(l)%frac(m,ind_veg_wall) =                                 &
                                    building_surface_pars_f%pars(ind_s_wall_frac,is)
 
                        IF ( building_surface_pars_f%pars(ind_s_green_frac_w,is) /=             &
                             building_surface_pars_f%fill )                                     &
-                          surf_usm_v(l)%frac(ind_pav_green,m) =                                &
+                          surf_usm_v(l)%frac(m,ind_pav_green) =                                &
                                    building_surface_pars_f%pars(ind_s_green_frac_w,is)
 
                        IF ( building_surface_pars_f%pars(ind_s_green_frac_r,is) /=             &
                             building_surface_pars_f%fill )                                     &
-                          surf_usm_v(l)%frac(ind_pav_green,m) =                                &
+                          surf_usm_v(l)%frac(m,ind_pav_green) =                                &
                                    building_surface_pars_f%pars(ind_s_green_frac_r,is)
                                    !TODO clarify: why should _w and _r be on the same surface?
@@ -4893,5 +4894,5 @@
                        IF ( building_surface_pars_f%pars(ind_s_win_frac,is) /=                 &
                             building_surface_pars_f%fill )                                     &
-                          surf_usm_v(l)%frac(ind_wat_win,m) =                                  &
+                          surf_usm_v(l)%frac(m,ind_wat_win) =                                  &
                                    building_surface_pars_f%pars(ind_s_win_frac,is)
 
@@ -4973,15 +4974,15 @@
                        IF ( building_surface_pars_f%pars(ind_s_emis_wall,is) /=      &
                             building_surface_pars_f%fill )                           &
-                          surf_usm_v(l)%emissivity(ind_veg_wall,m) =                 &
+                          surf_usm_v(l)%emissivity(m,ind_veg_wall) =                 &
                                    building_surface_pars_f%pars(ind_s_emis_wall,is)
 
                        IF ( building_surface_pars_f%pars(ind_s_emis_green,is) /=     &
                             building_surface_pars_f%fill )                           &
-                          surf_usm_v(l)%emissivity(ind_pav_green,m) =                &
+                          surf_usm_v(l)%emissivity(m,ind_pav_green) =                &
                                    building_surface_pars_f%pars(ind_s_emis_green,is)
 
                        IF ( building_surface_pars_f%pars(ind_s_emis_win,is) /=       &
                             building_surface_pars_f%fill )                           &
-                          surf_usm_v(l)%emissivity(ind_wat_win,m) =                  &
+                          surf_usm_v(l)%emissivity(m,ind_wat_win) =                  &
                                    building_surface_pars_f%pars(ind_s_emis_win,is)
 
@@ -5015,5 +5016,5 @@
         relative_fractions_corrected = .FALSE.
         DO  m = 1, surf_usm_h%ns
-           sum_frac = SUM( surf_usm_h%frac(:,m) )
+           sum_frac = SUM( surf_usm_h%frac(m,:) )
            IF ( sum_frac /= 1.0_wp )  THEN
               relative_fractions_corrected = .TRUE.
@@ -5023,12 +5024,12 @@
 !--           driver creation. 
               IF ( sum_frac /= 0.0_wp )  THEN
-                 surf_usm_h%frac(:,m) = surf_usm_h%frac(:,m) / sum_frac
+                 surf_usm_h%frac(m,:) = surf_usm_h%frac(m,:) / sum_frac
 !
 !--           In case all relative fractions are erroneously set to zero,
 !--           set wall fraction to 1.
               ELSE
-                 surf_usm_h%frac(ind_veg_wall,m)  = 1.0_wp
-                 surf_usm_h%frac(ind_wat_win,m)   = 0.0_wp
-                 surf_usm_h%frac(ind_pav_green,m) = 0.0_wp
+                 surf_usm_h%frac(m,ind_veg_wall)  = 1.0_wp
+                 surf_usm_h%frac(m,ind_wat_win)   = 0.0_wp
+                 surf_usm_h%frac(m,ind_pav_green) = 0.0_wp
               ENDIF
            ENDIF
@@ -5051,5 +5052,5 @@
         DO  l = 0, 3
            DO  m = 1, surf_usm_v(l)%ns
-              sum_frac = SUM( surf_usm_v(l)%frac(:,m) )
+              sum_frac = SUM( surf_usm_v(l)%frac(m,:) )
               IF ( sum_frac /= 1.0_wp )  THEN
                  relative_fractions_corrected = .TRUE.
@@ -5057,12 +5058,12 @@
 !--              Normalize relative fractions to 1.
                  IF ( sum_frac /= 0.0_wp )  THEN
-                    surf_usm_v(l)%frac(:,m) = surf_usm_v(l)%frac(:,m) / sum_frac
+                    surf_usm_v(l)%frac(m,:) = surf_usm_v(l)%frac(m,:) / sum_frac
 !
 !--              In case all relative fractions are erroneously set to zero,
 !--              set wall fraction to 1.
                  ELSE
-                    surf_usm_v(l)%frac(ind_veg_wall,m)  = 1.0_wp
-                    surf_usm_v(l)%frac(ind_wat_win,m)   = 0.0_wp
-                    surf_usm_v(l)%frac(ind_pav_green,m) = 0.0_wp
+                    surf_usm_v(l)%frac(m,ind_veg_wall)  = 1.0_wp
+                    surf_usm_v(l)%frac(m,ind_wat_win)   = 0.0_wp
+                    surf_usm_v(l)%frac(m,ind_pav_green) = 0.0_wp
                  ENDIF
               ENDIF
@@ -5367,11 +5368,11 @@
                                          - t_wall_h(nzb_wall,m) ) *                &
                                          surf_usm_h%ddz_wall(nzb_wall+1,m)         &
-                                       + surf_usm_h%frac(ind_veg_wall,m)           &
-                                         / (surf_usm_h%frac(ind_veg_wall,m)        &
-                                           + surf_usm_h%frac(ind_pav_green,m) )    &
+                                       + surf_usm_h%frac(m,ind_veg_wall)           &
+                                         / (surf_usm_h%frac(m,ind_veg_wall)        &
+                                           + surf_usm_h%frac(m,ind_pav_green) )    &
                                          * surf_usm_h%wghf_eb(m)                   &
-                                       - surf_usm_h%frac(ind_pav_green,m)          &
-                                          / (surf_usm_h%frac(ind_veg_wall,m)       &
-                                            + surf_usm_h%frac(ind_pav_green,m) )   &
+                                       - surf_usm_h%frac(m,ind_pav_green)          &
+                                          / (surf_usm_h%frac(m,ind_veg_wall)       &
+                                            + surf_usm_h%frac(m,ind_pav_green) )   &
                                          * ( surf_usm_h%lambda_h_green(nzt_wall,m)* wall_mod(nzt_wall) &
                                            * surf_usm_h%ddz_green(nzt_wall,m)      &
